// This file was generated by gir (https://github.com/gtk-rs/gir)
// from gir-files (https://github.com/gtk-rs/gir-files)
// DO NOT EDIT

#[cfg(any(feature = "v1_0", feature = "dox"))]
use Constraint;
use emeus_sys;
#[cfg(any(feature = "v1_0", feature = "dox"))]
use glib::GString;
use glib::object::Cast;
use glib::object::IsA;
use glib::translate::*;
use gtk;
use std::fmt;

glib_wrapper! {
    pub struct ConstraintLayoutChild(Object<emeus_sys::EmeusConstraintLayoutChild, emeus_sys::EmeusConstraintLayoutChildClass, ConstraintLayoutChildClass>) @extends gtk::Bin, gtk::Container, gtk::Widget;

    match fn {
        get_type => || emeus_sys::emeus_constraint_layout_child_get_type(),
    }
}

impl ConstraintLayoutChild {
    #[cfg(any(feature = "v1_0", feature = "dox"))]
    pub fn new(name: Option<&str>) -> ConstraintLayoutChild {
        unsafe {
            gtk::Widget::from_glib_full(emeus_sys::emeus_constraint_layout_child_new(name.to_glib_none().0)).unsafe_cast()
        }
    }
}

pub const NONE_CONSTRAINT_LAYOUT_CHILD: Option<&ConstraintLayoutChild> = None;

pub trait ConstraintLayoutChildExt: 'static {
    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn add_constraint<P: IsA<Constraint>>(&self, constraint: &P);

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn clear_constraints(&self);

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_bottom(&self) -> i32;

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_center_x(&self) -> i32;

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_center_y(&self) -> i32;

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_height(&self) -> i32;

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_left(&self) -> i32;

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_name(&self) -> Option<GString>;

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_right(&self) -> i32;

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_top(&self) -> i32;

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_width(&self) -> i32;

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn remove_constraint<P: IsA<Constraint>>(&self, constraint: &P);

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn set_intrinsic_height(&self, height: i32);

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn set_intrinsic_width(&self, width: i32);
}

impl<O: IsA<ConstraintLayoutChild>> ConstraintLayoutChildExt for O {
    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn add_constraint<P: IsA<Constraint>>(&self, constraint: &P) {
        unsafe {
            emeus_sys::emeus_constraint_layout_child_add_constraint(self.as_ref().to_glib_none().0, constraint.as_ref().to_glib_none().0);
        }
    }

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn clear_constraints(&self) {
        unsafe {
            emeus_sys::emeus_constraint_layout_child_clear_constraints(self.as_ref().to_glib_none().0);
        }
    }

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_bottom(&self) -> i32 {
        unsafe {
            emeus_sys::emeus_constraint_layout_child_get_bottom(self.as_ref().to_glib_none().0)
        }
    }

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_center_x(&self) -> i32 {
        unsafe {
            emeus_sys::emeus_constraint_layout_child_get_center_x(self.as_ref().to_glib_none().0)
        }
    }

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_center_y(&self) -> i32 {
        unsafe {
            emeus_sys::emeus_constraint_layout_child_get_center_y(self.as_ref().to_glib_none().0)
        }
    }

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_height(&self) -> i32 {
        unsafe {
            emeus_sys::emeus_constraint_layout_child_get_height(self.as_ref().to_glib_none().0)
        }
    }

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_left(&self) -> i32 {
        unsafe {
            emeus_sys::emeus_constraint_layout_child_get_left(self.as_ref().to_glib_none().0)
        }
    }

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_name(&self) -> Option<GString> {
        unsafe {
            from_glib_none(emeus_sys::emeus_constraint_layout_child_get_name(self.as_ref().to_glib_none().0))
        }
    }

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_right(&self) -> i32 {
        unsafe {
            emeus_sys::emeus_constraint_layout_child_get_right(self.as_ref().to_glib_none().0)
        }
    }

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_top(&self) -> i32 {
        unsafe {
            emeus_sys::emeus_constraint_layout_child_get_top(self.as_ref().to_glib_none().0)
        }
    }

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn get_width(&self) -> i32 {
        unsafe {
            emeus_sys::emeus_constraint_layout_child_get_width(self.as_ref().to_glib_none().0)
        }
    }

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn remove_constraint<P: IsA<Constraint>>(&self, constraint: &P) {
        unsafe {
            emeus_sys::emeus_constraint_layout_child_remove_constraint(self.as_ref().to_glib_none().0, constraint.as_ref().to_glib_none().0);
        }
    }

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn set_intrinsic_height(&self, height: i32) {
        unsafe {
            emeus_sys::emeus_constraint_layout_child_set_intrinsic_height(self.as_ref().to_glib_none().0, height);
        }
    }

    #[cfg(any(feature = "v1_0", feature = "dox"))]
    fn set_intrinsic_width(&self, width: i32) {
        unsafe {
            emeus_sys::emeus_constraint_layout_child_set_intrinsic_width(self.as_ref().to_glib_none().0, width);
        }
    }
}

impl fmt::Display for ConstraintLayoutChild {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "ConstraintLayoutChild")
    }
}
